// JavaScript Document
var cs;
var cc;

var cW;
var cH;

var type;

var base;

var span;

var cardCount;

var numArray;

var groupArray;

var groupLength;

var rectCont;
var rectArray;

var idArray;

var maxID;

var animeFlag;

//個別に設定するコンテンツの高さ
function getContentHeight()
{
	return 720;
}

function loadContentHandler()
{
	try
	{
		//スマートフォン
		var ua = navigator.userAgent;
		if(ua.indexOf('iPhone') > 0 || ua.indexOf('iPod') > 0 || ua.indexOf('Android') > 0 && ua.indexOf('Mobile') > 0)
		{
			browse = true;
		}
		//タブレット
		else if(ua.indexOf('iPad') > 0 || ua.indexOf('Android') > 0)
		{
			browse = true;
		}
		else
		{
			browse = false;
		}
		
		cc = document.getElementById("contentCanvas");
		cs = new createjs.Stage(cc);
		createjs.Touch.enable(cs);
		
		cW = 840;
		cH = 630;
		
		window.addEventListener("beforeunload", beforeUnloadHandler);
		
		document.getElementById("content").style.marginLeft = "10px";
		document.getElementById("contentCanvas").style.border = "1px solid #000000";
		
		document.getElementById("buttonBlock").style.width = "800px";
		
		base = new createjs.Shape();
		base.name = "base";
		cs.addChild(base);
		
		rectCont = new createjs.Container();
		rectCont.name = "rectCont";
		cs.addChild(rectCont);
		
		document.getElementById("cardSelect").style.fontSize = "1.25em";
		document.getElementById("cardSelect").style.display = "inline-block";
		document.getElementById("cardSelect").style.paddingLeft = "5px";
		document.getElementById("cardSelect").style.paddingRight = "5px";
		document.getElementById("cardSelect").style.verticalAlign = "0.5em";
		
		span = 30;
		
		type = 0;
		
		animeFlag = false;
		
		cardCount = 4;
		document.getElementById("cardSelect").value = 4;
		getGroupCombination(4, 3);
		
		document.getElementById("cardSelect").addEventListener("change", changeCardCountHandler);
		
		rectArray = [];
		numArray = [];
		
		initCanvas();
		changeTreePosition();
		
		document.getElementById("typeBtn0").style.display = "none";
		document.getElementById("typeBtn2").style.display = "none";
		document.getElementById("typeBtn3").style.display = "none";
		
		document.getElementById("typeBtn0").addEventListener("click", changeTypeButtonHandler);
		document.getElementById("typeBtn1").addEventListener("click", changeTypeButtonHandler);
		document.getElementById("typeBtn2").addEventListener("click", changeTypeButtonHandler);
		document.getElementById("typeBtn3").addEventListener("click", changeTypeButtonHandler);
		
		createjs.Ticker.setFPS(30);
		createjs.Ticker.setPaused(true);
		
		cs.update();
		
		checkVersionHandler("1.1.0");
	}
	catch(e)
	{
		alert("loadContentHandler:" + e.toString());
	}
}

function tickerHandler(e)
{
	cs.update();
}

function tickCompleteHandler(e)
{
	try
	{
		createjs.Ticker.removeEventListener('tick', tickerHandler);
		createjs.Ticker.setPaused(true);
		createjs.Tween.removeAllTweens();
		
		if(type == 1 || type == 2)
		{
			//同じ取り出しの１グループあたりの数
			var groupNum = groupLength/maxID;

			var i;

			//グループの位置の設定のための配列
			var pArray = [];
			var pW = span;
			var pH = span;
			for(i=1; i<=maxID; i++)
			{
				pArray[i] = [pW, pH];

				if(pH + 2 *(span * groupNum + 10) > cH)
				{
					pW += span * 4;
					pH = span;
				}
				else
				{
					pH += span * groupNum + 10;
				}
			}
			
			if(type == 1)
			{
				//まとまりの矩形
				base.graphics.clear();
				base.graphics.setStrokeStyle(2);
				base.graphics.beginStroke("rgba(255, 0, 0, 0.5)");
				base.graphics.beginFill("rgba(255, 0, 0, 0.25)");

				for(i=1; i<pArray.length; i++)
				{
					base.graphics.drawRect(pArray[i][0]-15, pArray[i][1]-15, span * 3, span * groupNum);
				}

				base.graphics.endFill();
				base.graphics.endStroke();
			}
			else
			{
				//まとまりの矩形
				base.graphics.clear();
				base.graphics.setStrokeStyle(2);
				base.graphics.beginStroke("rgba(0, 0, 255, 0.5)");
				base.graphics.beginFill("rgba(0, 0, 255, 0.25)");

				for(i=1; i<pArray.length; i++)
				{
					base.graphics.drawRect(pArray[i][0]-15, pArray[i][1]-15, span * 3, span);
				}

				base.graphics.endFill();
				base.graphics.endStroke();
			}
		}
		
		type++;
		
		changeControlHandler();
		animeFlag = false;
	}
	catch(e)
	{
		alert("tickCompleteHandler:" + e.toString());
	}
}

//各段階のグループの状態を作成
function getGroupCombination(n0, n1)
{
	try
	{
		//初期化
		groupArray = [];
		groupLength = 0;
		
		var base0 = [];
		var i=1;
		for(i; i<=n0; i++)
		{
			base0[i-1] = i;
		}
		
		for(i = 0; i<base0.length; i++)
		{
			groupArray[i] = [];
			var base1 = base0.slice();
			base1.splice(i, 1);
			
			for(j=0; j<base1.length; j++)
			{
				groupArray[i][j] = [];
			
				var base2 = base1.slice();
				base2.splice(j, 1);
				
				for(var k=0; k<base2.length; k++)
				{
					groupArray[i][j][k] = [base0[i], base1[j], base2[k]];
					groupLength++;
				}
			}
		}
	}
	catch(e)
	{
		alert("getGroupCombination:" + e.toString());
	}
}


function getCombination(arr, num)
{
	try
	{
		var arrs, i, j, z, k;
		
		arrs = [];
		z = arr.length;
		if(z < num)
		{
			return;
		}
		else if(num == 1)
		{
			for(i = 0; i < z; i++)
			{
				arrs[i] = [arr[i]];
			}
		}
		else
		{
			for(i = 0; i < z - num + 1; i ++)
			{
				k = getCombination(arr.slice(i + 1), num - 1);
				for(j = 0; j < k.length; j ++)
				{
					arrs.push([arr[i]].concat(k[j]));
				}
			}
		}
		
		return arrs;
	}
	catch(e)
	{
		alert("getCombination:" + e.toString());
	}
}

function createNumberContainer(num, str)
{
	try
	{
		var c = new createjs.Container();
		c.name = str;
		var t = new createjs.Text(num, "16px Times New Roman", "#000000");
		t.name = "text";
		
		var b = new createjs.Shape();
		b.name = "back";
		b.graphics.setStrokeStyle(1);
		b.graphics.beginStroke("#000000");
		b.graphics.beginFill("#FFFFFF");
		b.graphics.drawRect(0, 0, 18, 18);
		b.x = -9;
		b.y = -9;
		c.addChild(b);
		
		c.addChild(t);
		t.x = -t.getBounds().width/2;
		t.y = -t.getBounds().height/2+1;
		
		return c;
		
	}
	catch(e)
	{
		alert("createNumberContainer:" + e.toString());
	}
}

function changeCardCountHandler(e)
{
	try
	{
		if(animeFlag == false)
		{
			cardCount = e.target.value;

			getGroupCombination(cardCount, 3);

			initCanvas();
			changeTreePosition();
			
			cs.update();
		}
		else
		{
			document.getElementById("cardSelect").value = cardCount;
		}	
	}
	catch(e)
	{
		alert("changeCardCountHandler:" + e.toString());
	}
}

function changeTypeButtonHandler(e)
{
	try
	{
		if(animeFlag == false)
		{
			var t = parseInt(e.target.id.substring(e.target.id.length-1, e.target.id.length));
			
			switch(t)
			{
				case 0:
					changeTypeHandler(0);
					break;
				
				case 1:
					startLineUpAnime();
					break;
				
				case 2:
					//IDの設定
					setSameGroupID();
					startSameGroupAnime();
					break;
				
				case 3:
					//IDの設定
					setSameGroupID();
					startStackAnime();
					break;
			}
		}
	}
	catch(e)
	{
		alert("changeTypeHandler:" + e.toString());
	}
}

function changeTypeHandler(t)
{
	try
	{
		type = t;
		
		switch(type)
		{
			case 0:
				changeTreePosition();
				break;
			
			case 1:
				changeLineUpPosition();
				break;
			
			case 2:
				//IDの設定
				setSameGroupID();
				//並べ替え
				changeSameGroupPosition();
				break;
			
			case 3:
				//IDの設定
				setSameGroupID();
				//並べ替え
				changeStackPosition();
				break;
		}
		
		changeControlHandler();
		
		cs.update();
	}
	catch(e)
	{
		alert("changeTypeHandler:" + e.toString());
	}
}

function changeControlHandler()
{
	try
	{
		switch(type)
		{
			case 0:
				document.getElementById("cardPar").style.display = "inline-block";
				document.getElementById("cardSelect").style.display = "inline-block";
				document.getElementById("typeBtn0").style.display = "none";
				document.getElementById("typeBtn1").style.display = "inline-block";
				document.getElementById("typeBtn2").style.display = "none";
				document.getElementById("typeBtn3").style.display = "none";
				break;
			
			case 1:
				document.getElementById("cardPar").style.display = "none";
				document.getElementById("cardSelect").style.display = "none";
				document.getElementById("typeBtn0").style.display = "inline-block";
				document.getElementById("typeBtn1").style.display = "none";
				document.getElementById("typeBtn2").style.display = "inline-block";
				document.getElementById("typeBtn3").style.display = "none";
				break;
			
			case 2:
				document.getElementById("cardPar").style.display = "none";
				document.getElementById("cardSelect").style.display = "none";
				document.getElementById("typeBtn0").style.display = "inline-block";
				document.getElementById("typeBtn1").style.display = "none";
				document.getElementById("typeBtn2").style.display = "none";
				document.getElementById("typeBtn3").style.display = "inline-block";
				break;
			
			case 3:
				document.getElementById("cardPar").style.display = "none";
				document.getElementById("cardSelect").style.display = "none";
				document.getElementById("typeBtn0").style.display = "inline-block";
				document.getElementById("typeBtn1").style.display = "none";
				document.getElementById("typeBtn2").style.display = "none";
				document.getElementById("typeBtn3").style.display = "none";
				break;
		}
		
		//選択矩形の設定
		if(type == 1)
		{
			setRectContainer();
		}
		else
		{
			resetRectContainer();
		}
	}
	catch(e)
	{
		alert("changeControlHandler:" + e.toString());
	}
}

function initCanvas()
{
	try
	{
		var i, j, k;
		j = numArray.length;
		
		for(i=0; i<j; i++)
		{
			cs.removeChild(numArray[i]);
		}
		
		//クリア
		numArray = [];
		
		for(var i=0; i<groupArray.length; i++)
		{
			for(var j=0; j<groupArray[i].length; j++)
			{
				for(var k=0; k<groupArray[i][j].length; k++)
				{
					var str0 = "n"+(groupArray[i][j][k][0].toString()+groupArray[i][j][k][1].toString()+groupArray[i][j][k][2].toString())+"_" +groupArray[i][j][k][0]; 
					var c0 = createNumberContainer(groupArray[i][j][k][0], str0);
					
					var str1 = "n"+(groupArray[i][j][k][0].toString()+groupArray[i][j][k][1].toString()+groupArray[i][j][k][2].toString())+"_" +groupArray[i][j][k][1]; 
					var c1 = createNumberContainer(groupArray[i][j][k][1], str1);
					
					var str2 = "n"+(groupArray[i][j][k][0].toString()+groupArray[i][j][k][1].toString()+groupArray[i][j][k][2].toString())+"_" +groupArray[i][j][k][2]; 
					var c2 = createNumberContainer(groupArray[i][j][k][2], str2);
					
					cs.addChild(c0);
					cs.addChild(c1);
					cs.addChild(c2);
				
					numArray.push(c0);
					numArray.push(c1);
					numArray.push(c2);
				}
			}
		}
	}
	catch(e)
	{
		alert("initCanvas:" + e.toString());
	}
}

function changeTreePosition()
{
	try
	{
		base.graphics.clear();
		base.graphics.setStrokeStyle(1);
		base.graphics.beginStroke("#000000");
		
		var f;
		
		for(var i=0; i<groupArray.length; i++)
		{
			for(var j=0; j<groupArray[i].length; j++)
			{
				f  = true;
				for(var k=0; k<groupArray[i][j].length; k++)
				{
					var c0 = cs.getChildByName("n"+(groupArray[i][j][k][0].toString()+groupArray[i][j][k][1].toString()+groupArray[i][j][k][2].toString())+"_" +groupArray[i][j][k][0]);
					var c1 = cs.getChildByName("n"+(groupArray[i][j][k][0].toString()+groupArray[i][j][k][1].toString()+groupArray[i][j][k][2].toString())+"_" +groupArray[i][j][k][1]);
					var c2 = cs.getChildByName("n"+(groupArray[i][j][k][0].toString()+groupArray[i][j][k][1].toString()+groupArray[i][j][k][2].toString())+"_" +groupArray[i][j][k][2]);
				
					c0.x = span + (span * 4) * i;
					c0.y = span + span * (groupArray[i].length*groupArray[i][j].length-1)/2;
					
					c1.x = span + (span * 4) * i + span;
					c1.y = span + span * (j * groupArray[i][j].length) + span * (groupArray[i][j].length-1)/2;
					
					c2.x = span + (span * 4) * i + span * 2;
					c2.y = span + span * ( j * groupArray[i][j].length + k);
					
					if(f)
					{
						base.graphics.moveTo(c0.x, c0.y);
						base.graphics.lineTo(c1.x, c1.y);
						f = false;
					}
					
					base.graphics.moveTo(c1.x, c1.y);
					base.graphics.lineTo(c2.x, c2.y);
				}
			}
		}
	}
	catch(e)
	{
		alert("changeTreePosition:" + e.toString());
	}
}

function startLineUpAnime()
{
	try
	{
		base.graphics.clear();
		
		animeFlag = true;
		
		for(var i=0; i<groupArray.length; i++)
		{
			for(var j=0; j<groupArray[i].length; j++)
			{
				for(var k=0; k<groupArray[i][j].length; k++)
				{
					var c0 = cs.getChildByName("n"+(groupArray[i][j][k][0].toString()+groupArray[i][j][k][1].toString()+groupArray[i][j][k][2].toString())+"_" +groupArray[i][j][k][0]);
					var c1 = cs.getChildByName("n"+(groupArray[i][j][k][0].toString()+groupArray[i][j][k][1].toString()+groupArray[i][j][k][2].toString())+"_" +groupArray[i][j][k][1]);
					var c2 = cs.getChildByName("n"+(groupArray[i][j][k][0].toString()+groupArray[i][j][k][1].toString()+groupArray[i][j][k][2].toString())+"_" +groupArray[i][j][k][2]);

					var py = c2.y;
					
					if(i==0 && j==0 && k==0)
					{
						createjs.Tween.get(c0).to({y:py}, 1000, createjs.Ease.circOut).call(tickCompleteHandler);
					}
					else
					{
						createjs.Tween.get(c0).to({y:py}, 1000, createjs.Ease.circOut);
					}
					
					createjs.Tween.get(c1).to({y:py}, 1000, createjs.Ease.circOut);
				}
			}
		}
		
		createjs.Ticker.addEventListener("tick", tickerHandler);
		createjs.Ticker.setPaused(false);
	}
	catch(e)
	{
		alert("changeLineUpAnime:" + e.toString());
	}
}

function changeLineUpPosition()
{
	try
	{
		base.graphics.clear();
		
		for(var i=0; i<groupArray.length; i++)
		{
			for(var j=0; j<groupArray[i].length; j++)
			{
				for(var k=0; k<groupArray[i][j].length; k++)
				{
					var c0 = cs.getChildByName("n"+(groupArray[i][j][k][0].toString()+groupArray[i][j][k][1].toString()+groupArray[i][j][k][2].toString())+"_" +groupArray[i][j][k][0]);
					var c1 = cs.getChildByName("n"+(groupArray[i][j][k][0].toString()+groupArray[i][j][k][1].toString()+groupArray[i][j][k][2].toString())+"_" +groupArray[i][j][k][1]);
					var c2 = cs.getChildByName("n"+(groupArray[i][j][k][0].toString()+groupArray[i][j][k][1].toString()+groupArray[i][j][k][2].toString())+"_" +groupArray[i][j][k][2]);
					
					c0.x = span + (span * 4) * i;
					
					c1.x = span + (span * 4) * i + span;
					
					c2.x = span + (span * 4) * i + span * 2;
					c2.y = span + span * ( j * groupArray[i][j].length + k);
					
					c0.y = c2.y;
					c1.y = c2.y;
				}
			}
		}
	}
	catch(e)
	{
		alert("changeLineUpPosition:" + e.toString());
	}
}

function setSameGroupID()
{
	try
	{
		//初期化
		idArray = [];
		
		var i, j, k;
		
		var sameArray = [];
		
		//並び順の設定
		for(i=0; i<groupArray.length; i++)
		{
			for(j=0; j<groupArray[i].length; j++)
			{
				for(k=0; k<groupArray[i][j].length; k++)
				{
					sameArray[sameArray.length] = groupArray[i][j][k].slice();
				}
			}
		}
		
		var id=1;
		
		for(i=0; i<sameArray.length; i++)
		{
			if(idArray[i] == null)
			{
				idArray[i] = id;
				id++;
			}
			
			for(j=i+1; j<sameArray.length; j++)
			{
				if(		sameArray[i].indexOf(sameArray[j][0]) != -1
				&&	sameArray[i].indexOf(sameArray[j][1]) != -1
				&&	sameArray[i].indexOf(sameArray[j][2]) != -1)
				{
					idArray[j] = idArray[i];
				}
			}
		}
		
		//最大のID
		maxID = id-1;
	}
	catch(e)
	{
		alert("setSameGroupID:" + e.toString());
	}
}

function startSameGroupAnime()
{
	try
	{
		base.graphics.clear();
		
		animeFlag = true;
		
		//同じ取り出しの１グループあたりの数
		var groupNum = groupLength/maxID;
		
		var i;
		
		//グループの位置の設定のための配列
		var pArray = [];
		var pW = span;
		var pH = span;
		for(i=1; i<=maxID; i++)
		{
			pArray[i] = [pW, pH];
			
			if(pH + 2 *(span * groupNum + 10) > cH)
			{
				pW += span * 4;
				pH = span;
			}
			else
			{
				pH += span * groupNum + 10;
			}
		}
		
		//グループ内の上から順番に並べるための配列
		var countArray = [];
		
		for(i=1; i<=maxID; i++)
		{
			countArray[i] = 0;
		}
		
		var cnt = 0;
		
		for(i=0; i<groupArray.length; i++)
		{
			for(j=0; j<groupArray[i].length; j++)
			{
				for(k=0; k<groupArray[i][j].length; k++)
				{
					var c0 = cs.getChildByName("n"+(groupArray[i][j][k][0].toString()+groupArray[i][j][k][1].toString()+groupArray[i][j][k][2].toString())+"_" +groupArray[i][j][k][0]);
					var c1 = cs.getChildByName("n"+(groupArray[i][j][k][0].toString()+groupArray[i][j][k][1].toString()+groupArray[i][j][k][2].toString())+"_" +groupArray[i][j][k][1]);
					var c2 = cs.getChildByName("n"+(groupArray[i][j][k][0].toString()+groupArray[i][j][k][1].toString()+groupArray[i][j][k][2].toString())+"_" +groupArray[i][j][k][2]);
					
					if(i==0 && j==0 && k==0)
					{
						createjs.Tween.get(c0).to({x:pArray[idArray[cnt]][0], y:pArray[idArray[cnt]][1] + span * countArray[idArray[cnt]]}, 1000, createjs.Ease.circOut).call(tickCompleteHandler);
					}
					else
					{
						createjs.Tween.get(c0).to({x:pArray[idArray[cnt]][0], y:pArray[idArray[cnt]][1] + span * countArray[idArray[cnt]]}, 1000, createjs.Ease.circOut);
					}
					
					createjs.Tween.get(c1).to({x:pArray[idArray[cnt]][0] + span, y:pArray[idArray[cnt]][1] + span * countArray[idArray[cnt]]}, 1000, createjs.Ease.circOut);
					createjs.Tween.get(c2).to({x:pArray[idArray[cnt]][0] + span * 2, y:pArray[idArray[cnt]][1] + span * countArray[idArray[cnt]]}, 1000, createjs.Ease.circOut)
					
					countArray[idArray[cnt]]++;
					
					cnt++;
				}
			}
		}
		
		createjs.Ticker.addEventListener("tick", tickerHandler);
		createjs.Ticker.setPaused(false);
	}
	catch(e)
	{
		alert("startSameGroupAnime:" + e.toString());
	}
}

function changeSameGroupPosition()
{
	try
	{
		//同じ取り出しの１グループあたりの数
		var groupNum = groupLength/maxID;
		
		var i;
		
		//グループの位置の設定のための配列
		var pArray = [];
		var pW = span;
		var pH = span;
		for(i=1; i<=maxID; i++)
		{
			pArray[i] = [pW, pH];
			
			if(pH + 2 *(span * groupNum + 10) > cH)
			{
				pW += span * 4;
				pH = span;
			}
			else
			{
				pH += span * groupNum + 10;
			}
		}
		
		//まとまりの矩形
		base.graphics.clear();
		base.graphics.setStrokeStyle(2);
		base.graphics.beginStroke("rgba(255, 0, 0, 0.5)");
		base.graphics.beginFill("rgba(255, 0, 0, 0.25)");
		
		for(i=1; i<pArray.length; i++)
		{
			base.graphics.drawRect(pArray[i][0]-15, pArray[i][1]-15, span * 3, span * groupNum);
		}
		
		base.graphics.endFill();
		base.graphics.endStroke();
		
		//グループ内の上から順番に並べるための配列
		var countArray = [];
		
		for(i=1; i<=maxID; i++)
		{
			countArray[i] = 0;
		}
		
		var cnt = 0;
		
		for(i=0; i<groupArray.length; i++)
		{
			for(j=0; j<groupArray[i].length; j++)
			{
				for(k=0; k<groupArray[i][j].length; k++)
				{
					var c0 = cs.getChildByName("n"+(groupArray[i][j][k][0].toString()+groupArray[i][j][k][1].toString()+groupArray[i][j][k][2].toString())+"_" +groupArray[i][j][k][0]);
					var c1 = cs.getChildByName("n"+(groupArray[i][j][k][0].toString()+groupArray[i][j][k][1].toString()+groupArray[i][j][k][2].toString())+"_" +groupArray[i][j][k][1]);
					var c2 = cs.getChildByName("n"+(groupArray[i][j][k][0].toString()+groupArray[i][j][k][1].toString()+groupArray[i][j][k][2].toString())+"_" +groupArray[i][j][k][2]);
					
					c0.x = pArray[idArray[cnt]][0];
					c0.y = pArray[idArray[cnt]][1] + span * countArray[idArray[cnt]];
					c1.x = pArray[idArray[cnt]][0] + span;
					c1.y = pArray[idArray[cnt]][1] + span * countArray[idArray[cnt]];
					c2.x = pArray[idArray[cnt]][0] + span * 2;
					c2.y = pArray[idArray[cnt]][1] + span * countArray[idArray[cnt]];
					
					countArray[idArray[cnt]]++;
					
					cnt++;
				}
			}
		}
	}
	catch(e)
	{
		alert("changeSameGroupPostion:" + e.toString());
	}
}

function setRectContainer()
{
	try
	{
		//深度を再設定
		cs.setChildIndex(rectCont, cs.getNumChildren-1);
		
		//矩形の生成とイベントの追加
		for(var i=0; i<groupArray.length; i++)
		{
			for(var j=0; j<groupArray[i].length; j++)
			{
				for(var k=0; k<groupArray[i][j].length; k++)
				{
					var c0 = cs.getChildByName("n"+(groupArray[i][j][k][0].toString()+groupArray[i][j][k][1].toString()+groupArray[i][j][k][2].toString())+"_" +groupArray[i][j][k][0]);
					
					var r = new createjs.Shape();
					r.name = "rect" + groupArray[i][j][k][0] + groupArray[i][j][k][1] + groupArray[i][j][k][2] ; 
					r.graphics.setStrokeStyle(0);
					r.graphics.beginFill("rgba(255, 255, 255, 0.05)");
					r.graphics.drawRect(0, 0, span * 3, span);
					r.graphics.endStroke();
					
					r.x = c0.x - 15;
					r.y = c0.y - 15;
					
					rectArray.push(r);
					
					rectCont.addChild(r);
					
					r.addEventListener("mousedown", selectRectHandler);
				}
			}
		}
	}
	catch(e)
	{
		alert("setRectContainer:" + e.toString());
	}
}

function resetRectContainer()
{
	try
	{
		var n = rectArray.length;
		
		//イベントと矩形の削除
		for(var i=0; i<n; i++)
		{
			rectArray[i].removeEventListener("mousedown", selectRectHandler);
			
			rectCont.removeChild(rectArray[i]);
		}
		
		rectArray = [];
	}
	catch(e)
	{
		alert("resetRectContainer:" + e.toString());
	}
}

function selectRectHandler(e)
{
	try
	{
		var n0 = parseInt(e.target.name.substring(4, 5));
		var n1 = parseInt(e.target.name.substring(5, 6));
		var n2 = parseInt(e.target.name.substring(6, 7));
		
		base.graphics.clear();
		
		base.graphics.setStrokeStyle(2);
		base.graphics.beginStroke("rgba(255, 0, 0, 0.5)");
		base.graphics.beginFill("rgba(255, 0, 0, 0.25)");
		
		for(var i=0; i<groupArray.length; i++)
		{
			for(var j=0; j<groupArray[i].length; j++)
			{
				for(var k=0; k<groupArray[i][j].length; k++)
				{
					if(groupArray[i][j][k].indexOf(n0) != -1 && groupArray[i][j][k].indexOf(n1) != -1 && groupArray[i][j][k].indexOf(n2) != -1)
					{
						var sRect = rectCont.getChildByName("rect"+groupArray[i][j][k][0].toString()+groupArray[i][j][k][1].toString()+groupArray[i][j][k][2].toString());
						base.graphics.drawRect(sRect.x, sRect.y, span * 3, span);
					}
				}
			}
		}
		
		base.graphics.endFill();
		base.graphics.endStroke();
		
		cs.update();
	}
	catch(e)
	{
		alert("selectRectHandler:" + e.toString());
	}
}

function startStackAnime()
{
	try
	{
		base.graphics.clear();
		
		animeFlag = true;
		
		//同じ取り出しの１グループあたりの数
		var groupNum = groupLength/maxID;
		
		var i, j, k;
		
		//グループの位置の設定のための配列
		var pArray = [];
		var pW = span;
		var pH = span;
		for(i=1; i<=maxID; i++)
		{
			pArray[i] = [pW, pH];
			
			if(pH + 2 *(span * groupNum + 10) > cH)
			{
				pW += span * 4;
				pH = span;
			}
			else
			{
				pH += span * groupNum + 10;
			}
		}
		
		//グループ内の上から順番に並べるための配列
		var countArray = [];
		
		for(i=1; i<=maxID; i++)
		{
			countArray[i] = 0;
		}
		
		var cnt = 0;
		
		var stackArray = [];
		
		var f = true;
		
		for(i=0; i<groupArray.length; i++)
		{
			for(j=0; j < groupArray[i].length; j++)
			{
				for(k=0; k<groupArray[i][j].length; k++)
				{
					var c0 = cs.getChildByName("n"+(groupArray[i][j][k][0].toString()+groupArray[i][j][k][1].toString()+groupArray[i][j][k][2].toString())+"_" +groupArray[i][j][k][0]);
					var c1 = cs.getChildByName("n"+(groupArray[i][j][k][0].toString()+groupArray[i][j][k][1].toString()+groupArray[i][j][k][2].toString())+"_" +groupArray[i][j][k][1]);
					var c2 = cs.getChildByName("n"+(groupArray[i][j][k][0].toString()+groupArray[i][j][k][1].toString()+groupArray[i][j][k][2].toString())+"_" +groupArray[i][j][k][2]);
					
					if(countArray[idArray[cnt]] == 0)
					{
						stackArray[idArray[cnt]] = [];
						stackArray[idArray[cnt]][groupArray[i][j][k][0]] = c0;
						stackArray[idArray[cnt]][groupArray[i][j][k][1]] = c1;
						stackArray[idArray[cnt]][groupArray[i][j][k][2]] = c2;
					}
					else
					{
						if(f)
						{
							createjs.Tween.get(c0).to({x:stackArray[idArray[cnt]][groupArray[i][j][k][0]] .x, y:stackArray[idArray[cnt]][groupArray[i][j][k][0]] .y}, 1000, createjs.Ease.circOut).call(tickCompleteHandler);
							f = false;
						}
						else
						{
							createjs.Tween.get(c0).to({x:stackArray[idArray[cnt]][groupArray[i][j][k][0]] .x, y:stackArray[idArray[cnt]][groupArray[i][j][k][0]] .y}, 1000, createjs.Ease.circOut);
						}

						createjs.Tween.get(c1).to({x:stackArray[idArray[cnt]][groupArray[i][j][k][1]] .x, y:stackArray[idArray[cnt]][groupArray[i][j][k][1]] .y}, 1000, createjs.Ease.circOut);
						createjs.Tween.get(c2).to({x:stackArray[idArray[cnt]][groupArray[i][j][k][2]] .x, y:stackArray[idArray[cnt]][groupArray[i][j][k][2]] .y}, 1000, createjs.Ease.circOut);
					}
					
					countArray[idArray[cnt]]++;
					
					cnt++;
				}
			}
		}
		
		createjs.Ticker.addEventListener("tick", tickerHandler);
		createjs.Ticker.setPaused(false);
	}
	catch(e)
	{
		alert("startStackAnime:" + e.toString());
	}
}

function changeStackPosition()
{
	try
	{
		//同じ取り出しの１グループあたりの数
		var groupNum = groupLength/maxID;
		
		var i, j, k;
		
		//グループの位置の設定のための配列
		var pArray = [];
		var pW = span;
		var pH = span;
		for(i=1; i<=maxID; i++)
		{
			pArray[i] = [pW, pH];
			
			if(pH + 2 *(span * groupNum + 10) > cH)
			{
				pW += span * 4;
				pH = span;
			}
			else
			{
				pH += span * groupNum + 10;
			}
		}
		
		//まとまりの矩形
		base.graphics.clear();
		base.graphics.setStrokeStyle(2);
		base.graphics.beginStroke("rgba(0, 0, 255, 0.5)");
		base.graphics.beginFill("rgba(0, 0, 255, 0.25)");
		
		for(i=1; i<pArray.length; i++)
		{
			base.graphics.drawRect(pArray[i][0]-15, pArray[i][1]-15, span * 3, span);
		}
		
		base.graphics.endFill();
		base.graphics.endStroke();
		
		//グループ内の上から順番に並べるための配列
		var countArray = [];
		
		for(i=1; i<=maxID; i++)
		{
			countArray[i] = 0;
		}
		
		var cnt = 0;
		
		var stackArray = [];
		
		for(i=0; i<groupArray.length; i++)
		{
			for(j=0; j < groupArray[i].length; j++)
			{
				for(k=0; k<groupArray[i][j].length; k++)
				{
					var c0 = cs.getChildByName("n"+(groupArray[i][j][k][0].toString()+groupArray[i][j][k][1].toString()+groupArray[i][j][k][2].toString())+"_" +groupArray[i][j][k][0]);
					var c1 = cs.getChildByName("n"+(groupArray[i][j][k][0].toString()+groupArray[i][j][k][1].toString()+groupArray[i][j][k][2].toString())+"_" +groupArray[i][j][k][1]);
					var c2 = cs.getChildByName("n"+(groupArray[i][j][k][0].toString()+groupArray[i][j][k][1].toString()+groupArray[i][j][k][2].toString())+"_" +groupArray[i][j][k][2]);
					
					if(countArray[idArray[cnt]] == 0)
					{
						c0.x = pArray[idArray[cnt]][0];
						c0.y = pArray[idArray[cnt]][1];
						c1.x = pArray[idArray[cnt]][0] + span;
						c1.y = pArray[idArray[cnt]][1];
						c2.x = pArray[idArray[cnt]][0] + span * 2;
						c2.y = pArray[idArray[cnt]][1];
						
						stackArray[idArray[cnt]] = [];
						stackArray[idArray[cnt]][groupArray[i][j][k][0]] = c0;
						stackArray[idArray[cnt]][groupArray[i][j][k][1]] = c1;
						stackArray[idArray[cnt]][groupArray[i][j][k][2]] = c2;
					}
					else
					{
						c0.x = stackArray[idArray[cnt]][groupArray[i][j][k][0]] .x;
						c0.y = stackArray[idArray[cnt]][groupArray[i][j][k][0]] .y;
						c1.x = stackArray[idArray[cnt]][groupArray[i][j][k][1]] .x;
						c1.y = stackArray[idArray[cnt]][groupArray[i][j][k][1]] .y;
						c2.x = stackArray[idArray[cnt]][groupArray[i][j][k][2]] .x;
						c2.y = stackArray[idArray[cnt]][groupArray[i][j][k][2]] .y;
					}
					
					countArray[idArray[cnt]]++;
					
					cnt++;
				}
			}
		}
	}
	catch(e)
	{
		alert("changeStackPosition:" + e.toString());
	}
}

function saveContent()
{
	try
	{
		var array = [];
		
		array[0] = cardCount;
		array[1] = type;
		
		return array;
	}
	catch(e)
	{
		alert("saveContent:" + e.toString());
	}
}

function loadContent(array)
{
	try
	{
		//
		if(cardCount != array[1])
		{
			cardCount = array[0];
			document.getElementById("cardSelect").value = cardCount;
			
			getGroupCombination(cardCount, 3);
			initCanvas();
		}
		
		type = array[1];
		changeTypeHandler(type);
		
		cs.update();
	}
	catch(e)
	{
		alert("loadContent:" + e.toString());
	}
}



function resetHandler(e)
{
	try
	{
		cardCount = 4;
		document.getElementById("cardSelect").value = cardCount;
		
		type = 0;
		changeTypeHandler(0);
		
		cs.update();
	}
	catch(e)
	{
		alert("resetHandler:" + e.toString());
	}
}

function beforeUnloadHandler(e)
{
	createjs.Tween.removeAllTweens();
	createjs.Ticker.removeAllEventListeners('tick');
	createjs.Ticker.reset();

	winodw.removeEventListener("beforeunload", beforeUnloadHandler);
}
