// JavaScript Document

var rotFlag;

var dW;
var dH;

var canvas;
var stage;
      
var scene;
var camera;
var renderer;
var controls;
var projector;

var dataArray;

var objectArray;
var pointArray;
var lineArray;
var planeArray;

var pvArray;
var selectArray;

var materialArray;

var selectPointMaterial;
var selectLineMaterial;
var selectPlaneMaterial;

var defaultMaterial;

var keyArray;

var selectModel;

var fullArray;

//個別に設定するコンテンツの高さ
function getContentHeight()
{
	return 920;
}

function loadContentHandler()
{
	try
	{
		rotFlag = true;
		var ua = navigator.userAgent;
		
		var imgList = document.getElementsByClassName("polyImage");
		
		for(var i=0; i<imgList.length; i++)
		{
			imgList[i].addEventListener("click", changeHandler);
		}
		
		if(ictMode)
		{
			$("#modelBlock").on('mousedown touchstart', selectObjectHandler);
		}
		else if(mFlag)
		{
			document.getElementById("modelBlock").addEventListener('touchstart', selectObjectHandler);
		}
		else
		{
			document.getElementById("modelBlock").addEventListener('mousedown', selectObjectHandler);
		}
		
		document.getElementById("selectAllBtn").addEventListener('click', selectAllHandler);
		
		document.getElementById("content").style.marginLeft = "10px";
		
		document.getElementById("selectAllBtn").style.marginTop = "10px";
		
		document.getElementById("resetBtn").addEventListener("click", resetHandler);
		
		//立体の設定
		init();
		
		checkVersionHandler("1.1.0");
	}
	catch(e)
	{
		alert("loadContentHandler:" + e.toString());
	}
}

function init()
{
	try
	{
		keyArray = [
			"A","B","C","D","E","F","G","H","I","J",
			"K","L","M","N","O","P","Q","R","S","T",
			"U","V","W","X","Y","Z","a","b","c","d",
			"e","f","g","h","i","j","k","l","m","n",
			"o","p","q","r","s","t","u","v","w","x",
			"y","z","0","1","2","3","4","5","6","7"];
		
		dW = 800;
		dH = 450;
		
		var dis = 16;
		
		selectModel = 0;
		
		//3Dの設定
		scene = new THREE.Scene();
		
		if(navigator.userAgent.indexOf("Chrome") != -1)
		{
			renderer = new THREE.WebGLRenderer({antialias: false});
		}
		else
		{
			renderer = new THREE.WebGLRenderer({antialias: true});
		}
		
		renderer.setSize(dW, dH);
		renderer.setClearColor( new THREE.Color(0xFFFFFF) );
		
		camera = new THREE.OrthographicCamera (-dW/dis, dW/dis, dH/dis, -dH/dis, -500, 1000);
		
		controls = new THREE.OrbitControls(camera, renderer.domElement);
		projector = new THREE.Projector();
		
		//線の設定
		lineMaterial = new THREE.LineBasicMaterial( {color: 0x000000, linewidth:1} );
		
		materialArray = [];
		
		//頂点，辺，面の数
		fullArray = [	[4,6,4],
						[8,12,6],
						[6,12,8],
						[20,30,12],
						[12,30,20]];
		
		//各立体の色のマテリアル
		materialArray[0] = new THREE.MeshBasicMaterial( { color: 0x9fabc0, opacity:1, transparent:false} );
		materialArray[1] = new THREE.MeshBasicMaterial( { color: 0x977d9a, opacity:1, transparent:false} );
		materialArray[2] = new THREE.MeshBasicMaterial( { color: 0xfde1da, opacity:1, transparent:false} );
		materialArray[3] = new THREE.MeshBasicMaterial( { color: 0xfce3bd, opacity:1, transparent:false} );
		materialArray[4] = new THREE.MeshBasicMaterial( { color: 0xc6e3e2, opacity:1, transparent:false} );
		//materialArray[5] = new THREE.MeshBasicMaterial( { color: 0xffffff, opacity:1, transparent:false} );
		//materialArray[6] = new THREE.MeshBasicMaterial( { color: 0x000000, opacity:1, transparent:false} );
		
		defaultMaterial = new THREE.MeshBasicMaterial( { color: 0xFF0000, opacity:0, transparent:true} );
		
		selectPointMaterial = new THREE.MeshBasicMaterial( { color: 0xFFC3DB, opacity:1, transparent:false} );
		selectLineMaterial = new THREE.MeshBasicMaterial( { color: 0xC3DBFF, opacity:1, transparent:false} );
		selectPlaneMaterial = new THREE.MeshBasicMaterial( { color: 0xEEFFEE, opacity:1, transparent:false} );
		
		document.getElementById("modelBlock").appendChild(renderer.domElement);
		
		camera.position.x = 0;
		camera.position.y = 0;
		camera.position.z = 100;
		
		//初期化
		dataArray = [];
		objectArray = [];
		pointArray = [];
		lineArray = [];
		planeArray = [];
		pvArray = [[],[],[],[],[],[]];
		selectArray = [];
		
		dataArray[0] = getTetra(14);
		dataArray[1] = getHexa(14);
		dataArray[2] = getOcta(20);
		dataArray[3] = getDodeca(8);
		dataArray[4] = getIcosa(12);
		//dataArray[5] = getSoccer(13);
		
		
		objectArray[0] = createRegularPolyhedron(0);
		objectArray[1] = createRegularPolyhedron(1);
		objectArray[2] = createRegularPolyhedron(2);
		objectArray[3] = createRegularPolyhedron(3);
		objectArray[4] = createRegularPolyhedron(4);
		//objectArray[5] = createRegularPolyhedron(5);
		
		
		objectArray[0].rotation.x = 55 * Math.PI/180;
		objectArray[0].rotation.y = 45 * Math.PI/180;
		
		objectArray[3].rotation.x = -45 * Math.PI/180;
		
		objectArray[4].rotation.x = 60 * Math.PI/180;
		
		scene.add(objectArray[0]);
		scene.add(objectArray[1]);
		scene.add(objectArray[2]);
		scene.add(objectArray[3]);
		scene.add(objectArray[4]);
		//scene.add(objectArray[5]);
		
		objectArray[0].visible = true;
		objectArray[1].visible = false;
		objectArray[2].visible = false;
		objectArray[3].visible = false;
		objectArray[4].visible = false;
		//objectArray[5].visible = false;
		
		//第１配列に点，第２配列に線，第３配列に面の選択状態を入れる
		selectArray[0] = [[],[],[]];
		selectArray[1] = [[],[],[]];
		selectArray[2] = [[],[],[]];
		selectArray[3] = [[],[],[]];
		selectArray[4] = [[],[],[]];
		//selectArray[5] = [[],[],[]];
		
		var i;
		var j;
		
		//頂点
		for(i=0; i<fullArray.length; i++)
		{
			for(j=0; j<60; j++)
			{
			
				if(j<fullArray[i][0])
				{
					selectArray[i][0][j] = false;
				}
				else
				{
					break;
				}
			}
		}
		
		//辺
		for(i=0; i<fullArray.length; i++)
		{
			for(j=0; j<90; j++)
			{
				if(j<fullArray[i][1])
				{
					selectArray[i][1][j] = false;
				}
				else
				{
					break;
				}
			}
		}
		
		//面
		for(i=0; i<fullArray.length; i++)
		{
			for(j=0; j<32; j++)
			{
				if(j<fullArray[i][2])
				{
					selectArray[i][2][j] = false;
				}
				else
				{
					break;
				}
			}
		}
		
		render();
	}
	catch(e)
	{
		alert("init:" + e.toString());
	}
}


function changeHandler(e)
{
	try
	{
		var str = e.target.id;
		var n = parseInt(str.substring(str.length-1, str.length));	
		
		if(selectModel != n)
		{
			objectArray[selectModel].visible = false;
			objectArray[n].visible = true;
			
			selectModel = n;
			
		}
	}
	catch(e)
	{
		alert("changeHandler:" + e.toString());
	}
}

function createRegularPolyhedron(n)
{
	try
	{
		pointArray[n] = [];
		lineArray[n] = [];
		planeArray[n] = [];
		
		var obj = new THREE.Object3D();
		
		var i;
		
		var cnt = Object.keys(dataArray[n].point).length;
		
		//点の作成
		for(i=0; i<cnt; i++)
		{
			var point = createPointSphere(dataArray[n].point[keyArray[i]][0], dataArray[n].point[keyArray[i]][1], dataArray[n].point[keyArray[i]][2], n);
			point.name = "pt"+i;
			obj.add(point);
			
			pointArray[n][i] = point;
		}
		
		cnt = dataArray[n].line.length;
		
		//辺の作成
		for(i=0; i<cnt; i++)
		{
			var str0 = dataArray[n].line[i].substring(0, 1);
			var str1 = dataArray[n].line[i].substring(1, 2);
			var p0 = dataArray[n].point[str0];
			var p1 = dataArray[n].point[str1];
			
			var g = new THREE.Geometry();
			g.vertices.push(
				new THREE.Vector3(p0[0], p0[1], p0[2]),
				new THREE.Vector3(p1[0], p1[1], p1[2])
				);
			
			var line = new THREE.Line(g, lineMaterial);
			obj.add(line);
			
			var cy = createLineCylinder(p0[0], p0[1], p0[2], p1[0], p1[1], p1[2]);
			cy.name = "ln"+i;
			
			obj.add(cy);
			
			lineArray[n][i] = cy;
		}
		
		cnt = dataArray[n].plane.length;
		
		//面の作成
		for(i=0; i<cnt; i++)
		{
			var plane = createPlane(n, i);
			plane.name = "pl"+i;
			obj.add(plane);
			
			planeArray[n][i] = plane;
		}
		
		objectArray[n] = obj;
		obj.name = "obj"+n;
		return obj;
	}
	catch(e)
	{
		alert("createRegularPolyhedron:" + e.toString());
	}
}

function createPointSphere(px, py, pz, n)
{
	try
	{
		var mesh = new THREE.Mesh(new THREE.SphereGeometry(3), defaultMaterial);
		mesh.position.x = px;
		mesh.position.y = py;
		mesh.position.z = pz;
		
		return mesh;
	}
	catch(e)
	{
		alert("createPointSphere:" + e.toString());
	}
}

//辺の見かけ上の選択用のシリンダー
function createLineCylinder(px0, py0, pz0, px1, py1, pz1)
{
	try
	{
		var r = getPointRotation([px0, py0, pz0],[px1, py1, pz1]);
		var h = getPointLength(px0, py0, pz0, px1, py1, pz1);
		
		var mesh = new THREE.Mesh(new THREE.CylinderGeometry(1, 1, h, 10, 10, true), defaultMaterial);
		
		mesh.rotation.y = r[0];
		mesh.rotation.z = r[1]+Math.PI/2;
		
		
		mesh.position.x = (px0+px1)/2;
		mesh.position.y = (py0+py1)/2;
		mesh.position.z = (pz0+pz1)/2;
		
		return mesh;
	}
	catch(e)
	{
		alert("createLineCylinder:" + e.toString());
	}
}


function createPlane(n, t)
{
	try
	{
		var mesh;
		
		var pv = [];
		var i;
		
		for(i=0; i<dataArray[n].plane[t].length; i++)
		{
			var str = dataArray[n].plane[t];
			pv.push(new THREE.Vector3(dataArray[n].point[str.substring(i, i+1)][0], dataArray[n].point[str.substring(i, i+1)][1], dataArray[n].point[str.substring(i, i+1)][2]));	
		}
		
		pvArray[n][t] = pv;
		
		if(n != 5 || (n == 5 && dataArray[n].plane[t].length == 6))
		{
			mesh = new THREE.Mesh(new THREE.ConvexGeometry(pv), materialArray[n]);
		}
		else
		{
			mesh = new THREE.Mesh(new THREE.ConvexGeometry(pv), materialArray[n+1]);
		}
		
		return mesh;
	}
	catch(e)
	{
		alert("createPlane:" + e.toString());
	}
}

//点p0から見た点p1の回転角
function getPointRotation(p0, p1)
{
	try
	{
		var r = new Array();
		
		var d = Math.sqrt((p1[0]-p0[0])*(p1[0]-p0[0])+(p1[2]-p0[2])*(p1[2]-p0[2]));
		
		//ｙ軸に合わせた回転
		r[0] = Math.atan2(p0[2]-p1[2], p1[0]-p0[0]);
		//x軸に合わせた回転
		r[1] = Math.atan2(p1[1]-p0[1], d);
		
		return r;
	}
	catch(e)
	{
		alert("getPointRotation:" + e.toString());
	}
}

//２点間の距離
function getPointLength(x0, y0, z0, x1, y1, z1)
{
	try
	{
		var length = Math.sqrt((x1-x0)*(x1-x0)+(y1-y0)*(y1-y0)+(z1-z0)*(z1-z0));
		
		return length;
	}
	catch(e)
	{
		alert("getPointLength:" + e.toString());
	}
}

function selectObjectHandler(e)
{
	try
	{
		var mouse = new THREE.Vector2();
		
		var elm = document.getElementById("modelBlock");
		
		var pX;
		var pY;
		
		if(e.type == "touchstart")
		{
			if(e.targetTouches == undefined)
			{
				pX = e.originalEvent.targetTouches[0].pageX - $(elm).offset().left;
				pY = e.originalEvent.targetTouches[0].pageY - $(elm).offset().top;
			}
			else
			{
				pX = e.targetTouches[0].pageX - $(elm).offset().left;
				pY = e.targetTouches[0].pageY - $(elm).offset().top;
			}
		}
		else
		{
			pX = e.pageX - $(elm).offset().left;
			pY = e.pageY - $(elm).offset().top;
		}
		
		mouse.x = (pX / dW) * 2 - 1;
		mouse.y = -(pY / dH) * 2 + 1;
		
		var ray = new THREE.Raycaster();
		
		ray.setFromCamera(mouse, camera);
		
		var intersects = ray.intersectObjects(objectArray[selectModel].children);
		
		if(intersects.length > 0)
		{
			rotFlag = false;
			
			if(e.type == "touchstart")
			{
				document.addEventListener("touchend", releaseHandler);
			}
			else
			{
				document.addEventListener("mouseup", releaseHandler);
			}
			
			changeSelectObject(intersects[0].object);
		}
	}
	catch(e)
	{
		//alert("selectObjectHandler:" + e.toString());
	}
}


function changeSelectObject(obj)
{
	try
	{
		var num = parseInt(obj.name.substring(2, obj.name.length));
		
		var type;
		
		//点
		if(obj.name.substring(0, 2) == "pt")
		{
			type = 0;
		}
		//線
		else if(obj.name.substring(0, 2) == "ln")
		{
			type = 1;
		}
		//面
		else if(obj.name.substring(0, 2) == "pl")
		{
			type = 2;
		}
		
		selectArray[selectModel][type][num] = !selectArray[selectModel][type][num];
		
		if(type == 0)
		{
			changeMaterial(obj, selectModel, type, selectArray[selectModel][type][num]);
		}
		else if(type == 1)
		{
			changeMaterial(obj, selectModel, type, selectArray[selectModel][type][num]);
		}
		else
		{
			changeMaterial(obj, selectModel, type, selectArray[selectModel][type][num]);
		}
		
		//選択の数値変更
		var selectNum = parseInt(document.getElementById("table_"+ obj.name.substring(0, 2) + selectModel).innerHTML);
		
		if(selectArray[selectModel][type][num])
		{
			selectNum++;
		}
		else
		{
			selectNum--;
		}
		
		if(fullArray[selectModel][type] == selectNum)
		{
			document.getElementById("table_"+ obj.name.substring(0, 2) + selectModel).style.color = "#FF0000";
		}
		else
		{
			document.getElementById("table_"+ obj.name.substring(0, 2) + selectModel).style.color = "#000000";
		}
		
		document.getElementById("table_"+ obj.name.substring(0, 2) + selectModel).innerHTML = selectNum;
	}
	catch(e)
	{
		//alert("changeSelectObject:"+e.toString());
	}
}

function selectAllHandler(e)
{
	try
	{
		var i = selectModel;
		
		for(var t=0; t<3; t++)
		{
			var array;
			var str;
			switch(t)
			{
				case 0:
					array = pointArray;
					str = "table_pt";
					break;
				case 1:
					array = lineArray;
					str = "table_ln";
					break;
				case 2:
					array = planeArray;
					str = "table_pl";
					break;
			}
			
			document.getElementById(str+i).innerHTML = fullArray[i][t];
			document.getElementById(str+i).style.color = "#FF0000";
			
			for(var k=0; k<fullArray[i][t]; k++)
			{
				selectArray[i][t][k] = true;
				changeMaterial(array[i][k], k, t, true);
			}
		}
	}
	catch(e)
	{
		alert("selectAllHandler:" + e.toString());
	}
}

function changeMaterial(mesh, n, t, f)
{
	try
	{
		if(t == 0)
		{
			if(f)
			{
				mesh.material = selectPointMaterial;
			}
			else
			{
				mesh.material = defaultMaterial;
			}
		}
		else if(t == 1)
		{
			if(f)
			{
				mesh.material = selectLineMaterial;
			}
			else
			{
				mesh.material = defaultMaterial;
			}
		}
		//面
		else if(t == 2)
		{
			if(f)
			{
				mesh.material = selectPlaneMaterial;
			}
			else
			{
				
				if(n != 5)
				{
					mesh.material = materialArray[n];
				}
				else
				{
					var index = parseInt(mesh.name.substring(2, mesh.name.length));
					if(dataArray[5].plane[index].length == 6)
					{
						mesh.material = materialArray[n];
					}
					else
					{
						mesh.material = materialArray[n+1];
					}
				}
			}
		}
		
	}
	catch(e)
	{
		alert("changePlaneMesh:" + e.toString());
	}
}

function releaseHandler(e)
{
	try
	{
		rotFlag = true;
		
		if(e.type == "touchend")
		{
			document.removeEventListener("touchend", releaseHandler);
		}
		else
		{
			document.removeEventListener("mouseup", releaseHandler);
		}
	}
	catch(e)
	{
		alert("releaseHandler:" + e.toString());
	}
}

function render()
{
	try
	{
		requestAnimationFrame(render);
		
		controls.update();
		
		renderer.render(scene, camera);
	}
	catch(e)
	{
		alert("render:" + e.toString());
	}
}


function saveContent()
{
	try
	{
		var array = [];
		
		array[0] = [];
		array[0][0] = camera.position.x;
		array[0][1] = camera.position.y;
		array[0][2] = camera.position.z;
		array[0][3] = controls.object.zoom;
		
		//表示している立体
		array[1] = selectModel;
		
		//各立体の選択状態
		array[2] = selectArray.slice();
		
		return array;
	}
	catch(e)
	{
		alert("saveContent:" + e.toString());
	}
}

function loadContent(array)
{
	try
	{
		//カメラの再設定
		camera.position.x = array[0][0];
		camera.position.y = array[0][1];
		camera.position.z = array[0][2];
		
		controls.object.zoom = array[0][3];
		controls.object.updateProjectionMatrix();
		
		
		if(selectModel != array[1])
		{
			objectArray[selectModel].visible = false;
			objectArray[array[1]].visible = true;
			
			selectModel = array[1];
		}
		
		//各立体
		for(var i=0; i<selectArray.length; i++)
		{
			for(var t=0; t<3; t++)
			{
				//表の再設定
				var str = "";
				
				//選択された要素の個数をカウント
				var cnt=0;
				
				//各オブジェクトの再設定
				for(var j=0; j<fullArray[i][t]; j++)
				{
					if(array[2][i][t][j])
					{
						cnt++;
					}
					
					if(array[2][i][t][j] != selectArray[i][t][j])
					{
						switch(t)
						{
							case 0:
								changeMaterial(pointArray[i][j], i, t, array[2][i][t][j]);
								break;
							case 1:
								changeMaterial(lineArray[i][j], i, t, array[2][i][t][j]);
								break;
							case 2:
								changeMaterial(planeArray[i][j], i, t, array[2][i][t][j]);
								break;
						}
					}
				}
				
				switch(t)
				{
					case 0:
						str = "table_pt";
						break;
					case 1:
						str = "table_ln";
						break;
					case 2:
						str = "table_pl";
						break;
				}
				
				if(fullArray[i][t] == cnt)
				{
					document.getElementById(str + i).style.color = "#FF0000";
				}
				else
				{
					document.getElementById(str + i).style.color = "#000000";
				}
				
				document.getElementById(str + i).innerHTML = cnt;
			}
			
		}
		
		selectArray = array[2].slice();
	}
	catch(e)
	{
		alert("loadContent:" + e.toString());
	}
}

function resetHandler(e)
{
	try
	{
		controls.reset();
		
		//カメラの位置
		camera.position.x = 0;
		camera.position.y = 0;
		camera.position.z = 100;
		
		//拡大の初期化
		controls.object.zoom = 1;
		controls.object.updateProjectionMatrix();
		
		var i = 0;
		var j = 0;
		var t = 0;
		
		//選択の解除
		//頂点
		for(i=0; i<fullArray.length; i++)
		{
			for(j=0; j<60; j++)
			{
				if(j<fullArray[i][t])
				{
					if(selectArray[i][t][j])
					{
						//選択の解除
						changeMaterial(pointArray[i][j], i, t, false);
					}
					
					selectArray[i][t][j] = false;
				}
				else
				{
					break;
				}
			}
		}
		
		t = 1;
		
		//辺
		for(i=0; i<fullArray.length; i++)
		{
			for(j=0; j<90; j++)
			{
				if(j<fullArray[i][t])
				{
					if(selectArray[i][t][j])
					{
						//選択の解除
						changeMaterial(lineArray[i][j], i, t, false);
					}
					
					selectArray[i][t][j] = false;
				}
				else
				{
					break;
				}
			}
		}
		
		t = 2;
		
		//面
		for(i=0; i<fullArray.length; i++)
		{
			for(j=0; j<32; j++)
			{
				if(j<fullArray[i][t])
				{
					if(selectArray[i][t][j])
					{
						//選択の解除
						changeMaterial(planeArray[i][j], i, t, false);
					}
					
					selectArray[i][t][j] = false;
				}
				else
				{
					break;
				}
			}
		}
		
		selectModel = 0;
		
		objectArray[0].visible = true;
		objectArray[1].visible = false;
		objectArray[2].visible = false;
		objectArray[3].visible = false;
		objectArray[4].visible = false;
		//objectArray[5].visible = false;
		
		//テーブルの初期化
		for(var i=0; i<=4; i++)
		{
			document.getElementById("table_pt"+i).innerHTML = "0";
			document.getElementById("table_pt"+i).style.color = "#000000";
			document.getElementById("table_ln"+i).innerHTML = "0";
			document.getElementById("table_ln"+i).style.color = "#000000";
			document.getElementById("table_pl"+i).innerHTML = "0";
			document.getElementById("table_pl"+i).style.color = "#000000";
		}
		
	}
	catch(e)
	{
		alert("resetHandler:" + e.toString());
	}
}