// JavaScript Document
//正四面体
function getTetra(rate)
{
	try
	{
		var pnt=[];
		pnt["A"] = [-rate, -rate, -rate];
		pnt["B"] = [-rate, rate, rate];
		pnt["C"] = [rate, -rate, rate];
		pnt["D"] = [rate, rate, -rate];
				
		var line=[];
		line[0] = "AD";
		line[1] = "DC";
		line[2] = "CA";
		line[3] = "CB";
		line[4] = "BA";
		line[5] = "DB";
		
		var plane = [];
		plane[0] = "ADC";
		plane[1] = "ACB";
		plane[2] = "ABD";
		plane[3] = "BCD";
		
		return {point:pnt, line:line, plane:plane};
	}
	catch(e)
	{
		alert("getTetra:" + e.toString());
	}
}

//正六面体
function getHexa(rate)
{
	try
	{
		var pnt=[];
		pnt["A"] = [-rate, -rate, -rate];
		pnt["B"] = [-rate, -rate, rate];
		pnt["C"] = [-rate, rate, -rate];
		pnt["D"] = [-rate, rate, rate];
		pnt["E"] = [rate, -rate, -rate];
		pnt["F"] = [rate, -rate, rate];
		pnt["G"] = [rate, rate, -rate];
		pnt["H"] = [rate, rate, rate];
		
		var line=[];
		line[0] = "AB";
		line[1] = "BD";
		line[2] = "DC";
		line[3] = "CA";
		line[4] = "CG";
		line[5] = "GE";
		line[6] = "EA";
		line[7] = "HF";
		line[8] = "FE";
		line[9] = "GH";
		line[10] = "HD";
		line[11] = "BF";
		
		var plane=[];
		plane[0] = "ABDC";
		plane[1] = "ACGE";
		plane[2] = "AEFB";
		plane[3] = "HFEG";
		plane[4] = "HDBF";
		plane[5] = "HGCD";
		
		return {point:pnt, line:line, plane:plane};
	}
	catch(e)
	{
		alert("getHexa:" + e.toString());	
	}
}

//正八面体
function getOcta(rate)
{
	try
	{
		var pnt=[];
		pnt["A"] = [-rate, 0, 0];
		pnt["B"] = [0, -rate, 0];
		pnt["C"] = [0, 0, -rate];
		pnt["D"] = [rate, 0, 0];
		pnt["E"] = [0, rate, 0];
		pnt["F"] = [0, 0, rate];
		
		var line=[];
		line[0] = "AC";
		line[1] = "CB";
		line[2] = "BA";
		line[3] = "AE";
		line[4] = "EC";
		line[5] = "AF";
		line[6] = "FE";
		line[7] = "BF";
		line[8] = "DB";
		line[9] = "CD";
		line[10] = "DE";
		line[11] = "DF";
		
		var plane=[];
		plane[0] = "ACB";
		plane[1] = "AEC";
		plane[2] = "AFE";
		plane[3] = "ABF";
		plane[4] = "DBC";
		plane[5] = "DCE";
		plane[6] = "DEF";
		plane[7] = "DFB";
		
		return {point:pnt, line:line, plane:plane};
	}
	catch(e)
	{
		alert("getOcta:" + e.toString());
	}
}



//正十二面体
function getDodeca(rate)
{
	try
	{
		const p = (1+Math.sqrt(5))/2;
		
		var a = rate;
		var b = rate * p;
		var c = rate * p * p;
		
		//頂点
		var pnt = [];
		pnt["A"] = [0, -a, -c];
		pnt["B"] = [0, a, -c];
		pnt["C"] = [0, -a, c];
		pnt["D"] = [0, a, c];
		pnt["E"] = [-a, -c, 0];
		pnt["F"] = [a, -c, 0];
		pnt["G"] = [-a, c, 0];
		pnt["H"] = [a, c, 0];
		pnt["I"] = [-c, 0, -a];
		pnt["J"] = [-c, 0, a];
		pnt["K"] = [c, 0, -a];
		pnt["L"] = [c, 0, a];
		pnt["M"] = [-b, -b, -b];
		pnt["N"] = [-b, -b, b];
		pnt["O"] = [-b, b, -b];
		pnt["P"] = [-b, b, b];
		pnt["Q"] = [b, -b, -b];
		pnt["R"] = [b, -b, b];
		pnt["S"] = [b, b, -b];
		pnt["T"] = [b, b, b];
		
		//辺
		var line = [];
		line[0] = "AB";
		line[1] = "BS";
		line[2] = "SK";
		line[3] = "KQ";
		line[4] = "QA";
		line[5] = "AM";
		line[6] = "MI";
		line[7] = "IO";
		line[8] = "OB";
		line[9] = "CD";
		line[10] = "DP";
		line[11] = "PJ";
		line[12] = "JN";
		line[13] = "NC";
		line[14] = "CR";
		line[15] = "RL";
		line[16] = "LT";
		line[17] = "TD";
		line[18] = "EF";
		line[19] = "FR";
		line[20] = "NE";
		line[21] = "EM";
		line[22] = "QF";
		line[23] = "GH";
		line[24] = "HS";
		line[25] = "OG";
		line[26] = "GP";
		line[27] = "TH";
		line[28] = "IJ";
		line[29] = "KL";
		
		//面
		var plane = [];
		plane[0] = "ABSKQ";
		plane[1] = "BAMIO";
		plane[2] = "CDPJN";
		plane[3] = "DCRLT";
		plane[4] = "EFRCN";
		plane[5] = "FEMAQ";
		plane[6] = "GHSBO";
		plane[7] = "HGPDT";
		plane[8] = "IJPGO";
		plane[9] = "JIMEN";
		plane[10] = "KLRFQ";
		plane[11] = "LKSHT";
		
		return {point:pnt, line:line, plane:plane};
	}
	catch(e)
	{
		alert("getDodeca:" + e.toString());	
	}
}

//正二十面体
function getIcosa(rate)
{
	try
	{
		const p = (1+Math.sqrt(5))/2;
		
		var a = rate;
		var b = rate * p;
		
		//頂点
		var pnt = [];
		pnt["A"] = [0, -a, -b];
		pnt["B"] = [0, a, -b];
		pnt["C"] = [0, -a, b];
		pnt["D"] = [0, a, b];
		pnt["E"] = [-b, 0, -a];
		pnt["F"] = [-b, 0, a];
		pnt["G"] = [b, 0, -a];
		pnt["H"] = [b, 0, a];
		pnt["I"] = [-a, -b, 0];
		pnt["J"] = [a, -b, 0];
		pnt["K"] = [-a, b, 0];
		pnt["L"] = [a, b, 0];
		
		//辺
		var line = [];
		line[0] = "AB";
		line[1] = "BG";
		line[2] = "GA";
		line[3] = "AE";
		line[4] = "EB";
		line[5] = "CD";
		line[6] = "DF";
		line[7] = "FC";
		line[8] = "CH";
		line[9] = "HD";
		line[10] = "EF";
		line[11] = "FK";
		line[12] = "KE";
		line[13] = "EI";
		line[14] = "IF";
		line[15] = "GH";
		line[16] = "HJ";
		line[17] = "JG";
		line[18] = "GL";
		line[19] = "LH";
		line[20] = "IJ";
		line[21] = "JC";
		line[22] = "CI";
		line[23] = "IA";
		line[24] = "AJ";
		line[25] = "KL";
		line[26] = "LB";
		line[27] = "BK";
		line[28] = "KD";
		line[29] = "DL";
		
		//面
		var plane = [];
		plane[0] = "ABG";
		plane[1] = "BAE";
		plane[2] = "CDF";
		plane[3] = "DCH";
		plane[4] = "EFK";
		plane[5] = "FEI";
		plane[6] = "GHJ";
		plane[7] = "HGL";
		plane[8] = "IJC";
		plane[9] = "JIA";
		plane[10] = "KLB";
		plane[11] = "LKD";
		plane[12] = "AGJ";
		plane[13] = "AIE";
		plane[14] = "BEK";
		plane[15] = "BLG";
		plane[16] = "CFI";
		plane[17] = "CJH";
		plane[18] = "DHL";
		plane[19] = "DKF";
			
		return {point:pnt, line:line, plane:plane};
	}
	catch(e)
	{
		alert("getIcosa:" + e.toString());	
	}
}

//サッカーボール（切頭二十面体）
function getSoccer(rate)
{
	try
	{
		//IDに設定する文字
		var strArray = [
			"A","B","C","D","E","F","G","H","I","J",
			"K","L","M","N","O","P","Q","R","S","T",
			"U","V","W","X","Y","Z","a","b","c","d",
			"e","f","g","h","i","j","k","l","m","n",
			"o","p","q","r","s","t","u","v","w","x",
			"y","z","0","1","2","3","4","5","6","7"];
		
		//ネットで引っ張ってきた切頭二十面体の頂点座標
		var baseArray = 
		[
			[1.694,0.130,1.021],
			[1.447,0.891,1.021],
			[0.800,1.101,1.441],
			[0.400,0.551,1.862],
			[0.647,-0.210,1.862],
			[1.294,-0.421,1.441],
			[0.400,1.652,1.021],
			[-0.400,1.652,1.021],
			[-0.800,1.101,1.441],
			[-0.400,0.551,1.862],
			[-1.447,0.891,1.021],
			[-1.694,0.130,1.021],
			[-1.294,-0.421,1.441],
			[-0.647,-0.210,1.862],
			[-1.294,-1.101,1.021],
			[-0.647,-1.571,1.021],
			[0.000,-1.361,1.441],
			[0.000,-0.681,1.862],
			[0.647,-1.571,1.021],
			[1.294,-1.101,1.021],
			[0.647,1.571,-1.021],
			[1.294,1.101,-1.021],
			[1.294,0.421,-1.441],
			[0.647,0.210,-1.862],
			[0.000,0.681,-1.862],
			[0.000,1.361,-1.441],
			[-1.294,1.101,-1.021],
			[-0.647,1.571,-1.021],
			[-0.647,0.210,-1.862],
			[-1.294,0.421,-1.441],
			[-1.447,-0.891,-1.021],
			[-1.694,-0.130,-1.021],
			[-0.400,-0.551,-1.862],
			[-0.800,-1.101,-1.441],
			[0.400,-1.652,-1.021],
			[-0.400,-1.652,-1.021],
			[0.400,-0.551,-1.862],
			[0.800,-1.101,-1.441],
			[1.694,-0.130,-1.021],
			[1.447,-0.891,-1.021],
			[1.694,0.971,-0.340],
			[1.447,1.311,0.340],
			[1.942,-0.210,0.340],
			[1.942,0.210,-0.340],
			[-0.400,1.912,-0.340],
			[-0.800,1.782,0.340],
			[0.800,1.782,0.340],
			[0.400,1.912,-0.340],
			[-1.942,0.210,-0.340],
			[-1.942,-0.210,0.340],
			[-1.447,1.311,0.340],
			[-1.694,0.971,-0.340],
			[-0.800,-1.782,-0.340],
			[-0.400,-1.912,0.340],
			[-1.694,-0.971,0.340],
			[-1.447,-1.311,-0.340],
			[1.447,-1.311,-0.340],
			[1.694,-0.971,0.340],
			[0.400,-1.912,0.340],
			[0.800,-1.782,-0.340]
		];
		
		//頂点の設定
		var pnt = [];
		for(var i=0; i<60; i++)
		{
			pnt[strArray[i]] = [baseArray[i][0] * rate, baseArray[i][1] * rate, baseArray[i][2] * rate];
		}
		
		//面を構成する頂点のbaseArrayのインデックスでのまとめ
		var planeIndex = 
		[
			[0,  1,  2,  3,  4,  5],
            [6,  7,  8,  9,  3,  2],
            [10, 11, 12, 13,  9,  8],
            [14, 15, 16, 17, 13, 12],
            [18, 19,  5,  4, 17, 16],
            [20, 21, 22, 23, 24, 25],
            [26, 27, 25, 24, 28, 29],
            [30, 31, 29, 28, 32, 33],
            [34, 35, 33, 32, 36, 37],
            [38, 39, 37, 36, 23, 22],
            [40, 41,  1,  0, 42, 43],
            [44, 45,  7,  6, 46, 47],
            [48, 49, 11, 10, 50, 51],
			[52, 53, 15, 14, 54, 55],
            [56, 57, 19, 18, 58, 59],
            [39, 38, 43, 42, 57, 56],
            [21, 20, 47, 46, 41, 40],
            [27, 26, 51, 50, 45, 44],
            [31, 30, 55, 54, 49, 48],
            [35, 34, 59, 58, 53, 52],
            [0,  5, 19, 57, 42],
            [2,  1, 41, 46,  6],
            [8,  7, 45, 50, 10],
            [12, 11, 49, 54, 14],
            [16, 15, 53, 58, 18],
            [4,  3,  9, 13, 17],
            [22, 21, 40, 43, 38],
            [20, 25, 27, 44, 47],
            [26, 29, 31, 48, 51],
            [30, 33, 35, 52, 55],
            [34, 37, 39, 56, 59],
            [24, 23, 36, 32, 28]
		];
		
		//面の設定
		var plane = [];
		for(i=0; i<planeIndex.length; i++)
		{
			var str = "";
			for(var j=0; j<planeIndex[i].length; j++)
			{
				str = str + strArray[planeIndex[i][j]];
			}
			
			plane[i] = str;
		}
		
		var line = [];
		
		for(i=0; i<planeIndex.length; i++)
		{
			for(var j=0; j<planeIndex[i].length; j++)
			{
				var strA;
				var strB;
				
				if(j == planeIndex[i].length-1)
				{
					strA = strArray[planeIndex[i][j]]+strArray[planeIndex[i][0]];
					strB = strArray[planeIndex[i][0]]+strArray[planeIndex[i][j]];
				}
				else
				{
					strA = strArray[planeIndex[i][j]]+strArray[planeIndex[i][j+1]];
					strB = strArray[planeIndex[i][j+1]]+strArray[planeIndex[i][j]];
				}
				
				//頂点の組み合わせを確認
				if(line.indexOf(strA) == -1 && line.indexOf(strB) == -1)
				{
					line.push(strA);
				}
				
			}
		}
		
		return {point:pnt, line:line, plane:plane};
	}
	catch(e)
	{
		alert("getSoccer:" + e.toString());
	}
}
